// {{{RME classifier 'Logical View::HelloWorld'

#ifndef HelloWorld_H
#define HelloWorld_H

#ifdef PRAGMA
#pragma interface "HelloWorld.h"
#endif

#include <RTSystem/HelloWorld.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
#include<iostream.h>
// }}}USR
// }}}RME

extern const RTActorClass HelloWorld;

#define SUPER RTActor
class HelloWorld_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

public:
	HelloWorld_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~HelloWorld_Actor( void );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* HelloWorld_H */

// }}}RME
