// {{{RME classifier 'Logical View::TrafficLight'

#ifndef TrafficLight_H
#define TrafficLight_H

#ifdef PRAGMA
#pragma interface "TrafficLight.h"
#endif

#include <RTSystem/Intersection.h>
#include <LightControl.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass TrafficLight;

#define SUPER RTActor
class TrafficLight_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'control'
	LightControl::Conjugate control;
	// }}}RME

public:
	TrafficLight_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~TrafficLight_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_goGreen( void );
	INLINE_CHAINS void chain4_goRed( void );
	INLINE_CHAINS void chain3_goYellow( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* TrafficLight_H */

// }}}RME
