// {{{RME classifier 'Logical View::Intersection'

#ifndef Intersection_H
#define Intersection_H

#ifdef PRAGMA
#pragma interface "Intersection.h"
#endif

#include <RTSystem/Intersection.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Intersection;

#define SUPER RTActor
class Intersection_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME capsuleRole 'controller'
	RTActorRef controller;
	// }}}RME
	// {{{RME capsuleRole 'north'
	RTActorRef north;
	// }}}RME
	// {{{RME capsuleRole 'south'
	RTActorRef south;
	// }}}RME
	// {{{RME capsuleRole 'east'
	RTActorRef east;
	// }}}RME
	// {{{RME capsuleRole 'west'
	RTActorRef west;
	// }}}RME

public:
	Intersection_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Intersection_Actor( void );
	virtual int _followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex );
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTComponentDescriptor rtg_capsule_roles[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Intersection_H */

// }}}RME
